import { xsd } from '@tpluscode/rdf-ns-builders';
const xsdString = xsd.string;
export function blankNode(term) {
    return `_:${term.value}`;
}
export function namedNode(term) {
    return `<${term.value}>`;
}
export function literal(term) {
    const value = `"${term.value}"`;
    if (term.language) {
        return `${value}@${term.language}`;
    }
    if (term.datatype && !term.datatype.equals(xsdString)) {
        return `${value}^^${namedNode(term.datatype)}`;
    }
    return value;
}
