"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const data_model_1 = require("@rdfjs/data-model");
const nquads_1 = require("./nquads");
const TemplateResult_1 = require("./TemplateResult");
class NTriplesStrategy extends nquads_1.NQuadsStrategy {
    evaluateDataset(dataset, options) {
        const singleGraph = dataset.match(null, null, null, options.graph);
        return super.evaluateDataset(singleGraph, options);
    }
    evaluateQuad(quad, options) {
        if (!options.graph.equals(quad.graph)) {
            return {
                value: '',
                prefixes: [],
            };
        }
        return super.evaluateQuad(data_model_1.triple(quad.subject, quad.predicate, quad.object), options);
    }
}
exports.NTriplesStrategy = NTriplesStrategy;
exports.ntriples = (strings, ...values) => new TemplateResult_1.TemplateResult({
    strings,
    values,
    tag: exports.ntriples,
    strategy: new NTriplesStrategy(),
    defaultOptions: {
        graph: data_model_1.defaultGraph(),
        sortGraphs: false,
    },
});
