"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const rdf_ns_builders_1 = require("@tpluscode/rdf-ns-builders");
const rdf_vocabularies_1 = require("@zazuko/rdf-vocabularies");
const ntriples = __importStar(require("./ntriples"));
const xsdString = rdf_ns_builders_1.xsd.string;
function blankNode(term) {
    return ntriples.blankNode(term);
}
exports.blankNode = blankNode;
function namedNode(term, base = '') {
    const baseRegex = new RegExp('^' + base);
    const shrunk = rdf_vocabularies_1.shrink(term.value);
    if (shrunk) {
        return {
            value: shrunk,
            prefixes: [
                shrunk.split(':')[0],
            ],
        };
    }
    return {
        value: `<${term.value.replace(baseRegex, '')}>`,
        prefixes: [],
    };
}
exports.namedNode = namedNode;
function literal(term, base = '') {
    if (!term.language && term.datatype && !term.datatype.equals(xsdString)) {
        const datatypeResult = namedNode(term.datatype, base);
        return {
            value: `"${term.value}"^^${datatypeResult.value}`,
            prefixes: datatypeResult.prefixes,
        };
    }
    return {
        value: ntriples.literal(term),
        prefixes: [],
    };
}
exports.literal = literal;
